--------------------------------------------------------------------------------
-- Copyright (c) 1995-2011 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 13.4
--  \   \         Application : sch2hdl
--  /   /         Filename : deathstar_onebyte.vhf
-- /___/   /\     Timestamp : 05/17/2012 12:47:01
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: sch2hdl -intstyle ise -family spartan3e -flat -suppress -vhdl C:/Xilinx/project/deathstar2/deathstar_onebyte.vhf -w C:/Xilinx/project/deathstar2/deathstar_onebyte.sch
--Design Name: deathstar_onebyte
--Device: spartan3e
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity deathstar_onebyte is
   port ( data_in       : in    std_logic_vector (7 downto 0); 
          kset_main     : in    std_logic; 
          main_clk      : in    std_logic; 
          memwrite      : in    std_logic; 
          read_address  : in    std_logic_vector (2 downto 0); 
          reset         : in    std_logic; 
          write_address : in    std_logic_vector (2 downto 0); 
          deathstar_out : out   std_logic_vector (7 downto 0));
end deathstar_onebyte;

architecture BEHAVIORAL of deathstar_onebyte is
   signal XLXN_15       : std_logic_vector (7 downto 0);
   signal XLXN_16       : std_logic_vector (7 downto 0);
   signal XLXN_17       : std_logic_vector (7 downto 0);
   signal XLXN_19       : std_logic_vector (7 downto 0);
   signal XLXN_21       : std_logic_vector (7 downto 0);
   signal XLXN_22       : std_logic_vector (7 downto 0);
   signal XLXN_23       : std_logic_vector (7 downto 0);
   signal XLXN_24       : std_logic_vector (7 downto 0);
   signal XLXN_25       : std_logic_vector (7 downto 0);
   signal XLXN_35       : std_logic_vector (7 downto 0);
   component memory_out
      port ( clk      : in    std_logic; 
             header   : in    std_logic_vector (7 downto 0); 
             data1    : in    std_logic_vector (7 downto 0); 
             data2    : in    std_logic_vector (7 downto 0); 
             data3    : in    std_logic_vector (7 downto 0); 
             data4    : in    std_logic_vector (7 downto 0); 
             address  : in    std_logic_vector (2 downto 0); 
             data_out : out   std_logic_vector (7 downto 0));
   end component;
   
   component memory
      port ( memwrite : in    std_logic; 
             clk      : in    std_logic; 
             address  : in    std_logic_vector (2 downto 0); 
             data_in  : in    std_logic_vector (7 downto 0); 
             header   : out   std_logic_vector (7 downto 0); 
             data1    : out   std_logic_vector (7 downto 0); 
             data2    : out   std_logic_vector (7 downto 0); 
             data3    : out   std_logic_vector (7 downto 0); 
             data4    : out   std_logic_vector (7 downto 0));
   end component;
   
   component keycontrol
      port ( dclk : in    std_logic; 
             rst  : in    std_logic; 
             kset : in    std_logic; 
             din  : in    std_logic_vector (7 downto 0); 
             key  : out   std_logic_vector (7 downto 0));
   end component;
   
   component encryptor
      port ( dclk : in    std_logic; 
             kset : in    std_logic; 
             key  : in    std_logic_vector (7 downto 0); 
             din  : in    std_logic_vector (7 downto 0); 
             dout : out   std_logic_vector (7 downto 0));
   end component;
   
begin
   XLXI_15 : memory_out
      port map (address(2 downto 0)=>read_address(2 downto 0),
                clk=>main_clk,
                data1(7 downto 0)=>XLXN_15(7 downto 0),
                data2(7 downto 0)=>XLXN_16(7 downto 0),
                data3(7 downto 0)=>XLXN_17(7 downto 0),
                data4(7 downto 0)=>XLXN_19(7 downto 0),
                header(7 downto 0)=>XLXN_21(7 downto 0),
                data_out(7 downto 0)=>deathstar_out(7 downto 0));
   
   XLXI_16 : memory
      port map (address(2 downto 0)=>write_address(2 downto 0),
                clk=>main_clk,
                data_in(7 downto 0)=>data_in(7 downto 0),
                memwrite=>memwrite,
                data1(7 downto 0)=>XLXN_25(7 downto 0),
                data2(7 downto 0)=>XLXN_24(7 downto 0),
                data3(7 downto 0)=>XLXN_23(7 downto 0),
                data4(7 downto 0)=>XLXN_22(7 downto 0),
                header(7 downto 0)=>XLXN_21(7 downto 0));
   
   XLXI_17 : keycontrol
      port map (dclk=>main_clk,
                din(7 downto 0)=>data_in(7 downto 0),
                kset=>kset_main,
                rst=>reset,
                key(7 downto 0)=>XLXN_35(7 downto 0));
   
   XLXI_18 : encryptor
      port map (dclk=>main_clk,
                din(7 downto 0)=>XLXN_25(7 downto 0),
                key(7 downto 0)=>XLXN_35(7 downto 0),
                kset=>kset_main,
                dout(7 downto 0)=>XLXN_15(7 downto 0));
   
   XLXI_19 : encryptor
      port map (dclk=>main_clk,
                din(7 downto 0)=>XLXN_24(7 downto 0),
                key(7 downto 0)=>XLXN_35(7 downto 0),
                kset=>kset_main,
                dout(7 downto 0)=>XLXN_16(7 downto 0));
   
   XLXI_20 : encryptor
      port map (dclk=>main_clk,
                din(7 downto 0)=>XLXN_23(7 downto 0),
                key(7 downto 0)=>XLXN_35(7 downto 0),
                kset=>kset_main,
                dout(7 downto 0)=>XLXN_17(7 downto 0));
   
   XLXI_21 : encryptor
      port map (dclk=>main_clk,
                din(7 downto 0)=>XLXN_22(7 downto 0),
                key(7 downto 0)=>XLXN_35(7 downto 0),
                kset=>kset_main,
                dout(7 downto 0)=>XLXN_19(7 downto 0));
   
end BEHAVIORAL;


