-- Vhdl test bench created from schematic C:\Xilinx\project\deathstar2\deathstar_onebyte.sch - Wed May 16 22:46:37 2012
--
-- Notes: 
-- 1) This testbench template has been automatically generated using types
-- std_logic and std_logic_vector for the ports of the unit under test.
-- Xilinx recommends that these types always be used for the top-level
-- I/O of a design in order to guarantee that the testbench will bind
-- correctly to the timing (post-route) simulation model.
-- 2) To use this template as your testbench, change the filename to any
-- name of your choice with the extension .vhd, and use the "Source->Add"
-- menu in Project Navigator to import the testbench. Then
-- edit the user defined section below, adding code to generate the 
-- stimulus for your design.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
LIBRARY UNISIM;
USE UNISIM.Vcomponents.ALL;
ENTITY deathstar_onebyte_deathstar_onebyte_sch_tb IS
END deathstar_onebyte_deathstar_onebyte_sch_tb;
ARCHITECTURE behavioral OF deathstar_onebyte_deathstar_onebyte_sch_tb IS 

   COMPONENT deathstar_onebyte
   PORT( main_clk			:	IN	STD_LOGIC; 
          kset_main		:	IN	STD_LOGIC; 
          data_in			:	IN	STD_LOGIC_VECTOR (7 DOWNTO 0); 
          write_address	:	IN	STD_LOGIC_VECTOR (2 DOWNTO 0); 
          read_address	:	IN	STD_LOGIC_VECTOR (2 DOWNTO 0); 
          deathstar_out	:	OUT	STD_LOGIC_VECTOR (7 DOWNTO 0); 
          reset			:	IN	STD_LOGIC; 
          memwrite		:	IN	STD_LOGIC);
   END COMPONENT;

   SIGNAL main_clk	:	STD_LOGIC;
   SIGNAL kset_main	:	STD_LOGIC;
   SIGNAL data_in	:	STD_LOGIC_VECTOR (7 DOWNTO 0);
   SIGNAL write_address	:	STD_LOGIC_VECTOR (2 DOWNTO 0);
   SIGNAL read_address	:	STD_LOGIC_VECTOR (2 DOWNTO 0);
   SIGNAL deathstar_out	:	STD_LOGIC_VECTOR (7 DOWNTO 0);
   SIGNAL reset	:	STD_LOGIC;
   SIGNAL memwrite	:	STD_LOGIC;
	
constant clk_period : time := 20 ps;
BEGIN

   UUT: deathstar_onebyte PORT MAP(
		main_clk => main_clk, 
		kset_main => kset_main, 
		data_in => data_in, 
		write_address => write_address, 
		read_address => read_address, 
		deathstar_out => deathstar_out, 
		reset => reset, 
		memwrite => memwrite
   );
   clk_process :process
   begin
main_clk <= '0';
		wait for clk_period/2;
		main_clk <= '1';
		wait for clk_period/2;
   end process;
-- *** Test Bench - User Defined Section ***
   tb : PROCESS
   BEGIN
	
	
		kset_main<='0';
		
		--now we need to put our file into the DEATHSTARS memory
		memwrite<='1';
		write_address<="000";
		data_in<="11110000";
		wait for 30ps;
		write_address<="001";
		data_in<="11110001";
		wait for 30ps;
		write_address<="010";
		data_in<="11110010";
		wait for 30ps;
		write_address<="011";
		data_in<="11110011";
		wait for 30ps;
		write_address<="100";
		data_in<="11110100";
		wait for 30ps;
		memwrite<='0';
		
		reset<='1';--make sure that the key is reset
		wait for 30ps;
		reset<='0';
		
		--this is now the primary key
		data_in<="01010101";
		read_address<="010";
		wait for 30ps;
		
		--immediately after we set kset_main to one
		--the data is encryoted and available to memory out.
		kset_main<='1';
		--wait for 30ns;
		
		wait for 100ps;
		read_address<="011";
		
	
	
      WAIT; -- will wait forever
   END PROCESS;
-- *** End Test Bench - User Defined Section ***

END;
