--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   20:47:47 05/16/2012
-- Design Name:   
-- Module Name:   C:/Xilinx/project/deathstar2/memory_tb.vhd
-- Project Name:  deathstar2
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: memory
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY memory_tb IS
END memory_tb;
 
ARCHITECTURE behavior OF memory_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT memory
    PORT(
         memwrite : IN  std_logic;
         address : IN  std_logic_vector(2 downto 0);
         data_in : IN  std_logic_vector(7 downto 0);
         clk : IN  std_logic;
         header : OUT  std_logic_vector(7 downto 0);
         data1 : OUT  std_logic_vector(7 downto 0);
         data2 : OUT  std_logic_vector(7 downto 0);
         data3 : OUT  std_logic_vector(7 downto 0);
         data4 : OUT  std_logic_vector(7 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal memwrite : std_logic := '0';
   signal address : std_logic_vector(2 downto 0) := (others => '0');
   signal data_in : std_logic_vector(7 downto 0) := (others => '0');
   signal clk : std_logic := '0';

 	--Outputs
   signal header : std_logic_vector(7 downto 0);
   signal data1 : std_logic_vector(7 downto 0);
   signal data2 : std_logic_vector(7 downto 0);
   signal data3 : std_logic_vector(7 downto 0);
   signal data4 : std_logic_vector(7 downto 0);

   -- Clock period definitions
   constant clk_period : time := 20 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: memory PORT MAP (
          memwrite => memwrite,
          address => address,
          data_in => data_in,
          clk => clk,
          header => header,
          data1 => data1,
          data2 => data2,
          data3 => data3,
          data4 => data4
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	

      wait for clk_period*10;

      -- insert stimulus here 
		memwrite<='1';
		address<="000";
		data_in<="11110000";
		wait for 30ns;
		address<="001";
		data_in<="11110001";
		wait for 30ns;
		address<="010";
		data_in<="11110010";
		wait for 30ns;
		address<="011";
		data_in<="11110011";
		wait for 30ns;
		address<="100";
		data_in<="11110000";
		wait for 30ns;
		memwrite<='0';
      wait;
   end process;

END;
